searchNodes=[{"ref":"TelemetryMetricsPrometheus.html","title":"TelemetryMetricsPrometheus","module":"TelemetryMetricsPrometheus","type":"module","doc":"Prometheus Reporter for Telemetry.Metrics definitions. Provide a list of metric definitions to the init/2 function. It&#39;s recommended to initialize the reporter during application startup. def start(_type, _args) do TelemetryMetricsPrometheus.init([ counter(&quot;http.request.count&quot;), sum(&quot;http.request.payload_size&quot;, unit: :byte), last_value(&quot;vm.memory.total&quot;, unit: :byte) ]) # List all child processes to be supervised children = [ ... ] opts = [strategy: :one_for_one, name: ExampleApp.Supervisor] Supervisor.start_link(children, opts) end By default, metrics are exposed on port 9568 at /metrics. The port number can be configured if necessary. You are not required to use the included server, though it is recommended. https is not supported yet, in which case exposing a /metrics endpoint and calling the scrape/1 function is your best option until TLS is supported. Note that aggregations for distributions (histogram) only occur at scrape time. These aggregations only have to process events that have occurred since the last scrape, so it&#39;s recommended at this time to keep an eye on scrape durations if you&#39;re reporting a large number of disributions or you have a high tag cardinality. Telemetry.Metrics to Prometheus Equivalents Metric types: Counter - Counter Distribution - Histogram (Summaries are not supported at this time) LastValue - Gauge Sum - Counter Units Prometheus recommends the usage of base units for compatibility - Base Units. This is simple to do with :telemetry and Telemetry.Metrics as all memory related measurements in the BEAM are reported in bytes and Metrics provides automatic time unit conversions. Note that measurement unit should used as part of the reported name in the case of histograms and gauges to Prometheus. As such, it is important to explicitly define the unit of measure for these types when the unit is time or memory related. It is suggested to not mix units, e.g. seconds with milliseconds. It is required to define your buckets according to the end unit translation since this measurements are converted at the time of handling the event, prior to bucketing. Memory Report memory as :byte. Time Report durations as :second. The BEAM and :telemetry events use :native time units. Converting to seconds is as simple as adding the conversion tuple for the unit - {:native, :second} Naming Telemetry.Metrics definition names do not translate easily to Prometheus naming conventions. By default, the name provided when creating your definition uses parts of the provided name to determine what event to listen to and which event measurement to use. For example, &quot;http.request.duration&quot; results in listening for [:http, :request] events and use :duration from the event measurements. Prometheus would recommend a name of http_request_duration_seconds as a good name. It is therefore recommended to use the name in your definition to reflect the name you wish to see reported, e.g. http.request.duration.seconds or [:http, :request, :duration, :seconds] and use the :event_name override and :measurement options in your definition. Example: Metrics.distribution( &quot;http.request.duration.seconds&quot;, buckets: [0.01, 0.025, 0.05, 0.1, 0.2, 0.5, 1], event_name: [:http, :request, :complete], measurement: :duration, unit: {:native, :second} ) The exporter sanitizes names to Prometheus&#39; requirements (Metric Naming) and joins the event name parts with an underscore. Labels Labels in Prometheus are referred to as :tags in Telemetry.Metrics - see the docs for more information on tag usage. Important: Each tag + value results in a separate time series. For distributions, this is further complicated as a time series is created for each bucket plus one for measurements exceeding the limit of the last bucket - +Inf. It is highly recommended to abide by Prometheus&#39; best practices regarding labels - Label Best Practices"},{"ref":"TelemetryMetricsPrometheus.html#init/2","title":"TelemetryMetricsPrometheus.init/2","module":"TelemetryMetricsPrometheus","type":"function","doc":"Initializes a reporter instance with the provided Telemetry.Metrics definitions. Available options: :name - name of the reporter instance. Defaults to :prometheus_metrics :port - port number for the reporter instance&#39;s server. Defaults to 9568"},{"ref":"TelemetryMetricsPrometheus.html#scrape/1","title":"TelemetryMetricsPrometheus.scrape/1","module":"TelemetryMetricsPrometheus","type":"function","doc":"Returns a metrics scrape in Prometheus exposition format for the given reporter name - defaults to :prometheus_metrics. Use this function if you wish to expose your metrics through your own server implementation, though this is not recommended. See the Overview for further discussion."},{"ref":"TelemetryMetricsPrometheus.html#t:metric/0","title":"TelemetryMetricsPrometheus.metric/0","module":"TelemetryMetricsPrometheus","type":"type","doc":""},{"ref":"TelemetryMetricsPrometheus.html#t:metrics/0","title":"TelemetryMetricsPrometheus.metrics/0","module":"TelemetryMetricsPrometheus","type":"type","doc":""},{"ref":"TelemetryMetricsPrometheus.html#t:prometheus_option/0","title":"TelemetryMetricsPrometheus.prometheus_option/0","module":"TelemetryMetricsPrometheus","type":"type","doc":""},{"ref":"TelemetryMetricsPrometheus.html#t:prometheus_options/0","title":"TelemetryMetricsPrometheus.prometheus_options/0","module":"TelemetryMetricsPrometheus","type":"type","doc":""},{"ref":"overview.html","title":"Overview","module":"overview","type":"extras","doc":"Overview TelemetryMetricsPrometheus is a Telemetry.Metrics Reporter for aggregating and exposing Prometheus metrics based on Telemetry.Metrics definitions. The reporter runs as a standalone application and provides its own web server. This makes it very simple to instrument your project, regardless of your project type! Let us know how you&#39;re using it."},{"ref":"overview.html#getting-started","title":"Overview - Getting Started","module":"overview","type":"extras","doc":"Once you have the package added to your dependencies, you can start TelemetryMetricsPrometheus by initiating the application during your application startup. def start(_type, _args) do TelemetryMetricsPrometheus.init([]) # List all child processes to be supervised children = [ ... ] opts = [strategy: :one_for_one, name: ExampleApp.Supervisor] Supervisor.start_link(children, opts) end There are a few metrics built into TelemetryMetricsPrometheus to monitor resource usage by the reporter and measure scrape processing time. To see it in action, fire up your application in your terminal iex -S mix. Open another terminal and curl the endpoint a few times to see the output. $ curl http://localhost:9568/metrics # HELP prometheus_metrics_table_size_total A gauge of the key count of a prometheus metrics aggregation table # TYPE prometheus_metrics_table_size_total gauge prometheus_metrics_table_size_total{name=&quot;prometheus_metrics_dist&quot;} 1 1555038768802809000 prometheus_metrics_table_size_total{name=&quot;prometheus_metrics&quot;} 4 1555038768802809000 # HELP prometheus_metrics_table_memory_bytes A gauge of the memory size of a prometheus metrics aggregation table # TYPE prometheus_metrics_table_memory_bytes gauge prometheus_metrics_table_memory_bytes{name=&quot;prometheus_metrics_dist&quot;} 1356 1555038768802809000 prometheus_metrics_table_memory_bytes{name=&quot;prometheus_metrics&quot;} 1426 1555038768802809000 # HELP prometheus_metrics_scrape_duration_seconds A histogram of the request duration for prometheus metrics scrape. # TYPE prometheus_metrics_scrape_duration_seconds histogram prometheus_metrics_scrape_duration_seconds_bucket{name=&quot;prometheus_metrics&quot;,le=&quot;0.05&quot;} 1 prometheus_metrics_scrape_duration_seconds_bucket{name=&quot;prometheus_metrics&quot;,le=&quot;0.1&quot;} 1 prometheus_metrics_scrape_duration_seconds_bucket{name=&quot;prometheus_metrics&quot;,le=&quot;0.2&quot;} 1 prometheus_metrics_scrape_duration_seconds_bucket{name=&quot;prometheus_metrics&quot;,le=&quot;0.5&quot;} 1 prometheus_metrics_scrape_duration_seconds_bucket{name=&quot;prometheus_metrics&quot;,le=&quot;1&quot;} 1 prometheus_metrics_scrape_duration_seconds_bucket{name=&quot;prometheus_metrics&quot;,le=&quot;+Inf&quot;} 1 prometheus_metrics_scrape_duration_seconds_sum{name=&quot;prometheus_metrics&quot;} 0.00213792 prometheus_metrics_scrape_duration_seconds_count{name=&quot;prometheus_metrics&quot;} 1 By default, metrics are exposed on port 9568 at /metrics. The port number can be configured if necessary. You are not required to use the included server, though it is recommended. https is not supported yet, in which case exposing a /metrics endpoint and calling the scrape/1 function is your best option until TLS is supported. Note that aggregations for distributions (histogram) only occur at scrape time. These aggregations only have to process events that have occurred since the last scrape, so it&#39;s recommended at this time to keep an eye on scrape durations if you&#39;re reporting a large number of disributions or you have a high tag cardinality."},{"ref":"overview.html#telemetry-metrics-to-prometheus-equivalents","title":"Overview - Telemetry.Metrics to Prometheus equivalents","module":"overview","type":"extras","doc":"Metric types: Counter - Counter Distribution - Histogram (Summaries are not supported at this time) LastValue - Gauge Sum - Counter Units Prometheus recommends the usage of base units for compatibility - Base Units. This is simple to do with :telemetry and Telemetry.Metrics as all memory related measurements in the BEAM are reported in bytes and Metrics provides automatic time unit conversions. Note that measurement unit should used as part of the reported name in the case of histograms and gauges to Prometheus. As such, it is important to explicitly define the unit of measure for these types when the unit is time or memory related. It is suggested to not mix units, e.g. seconds with milliseconds. It is required to define your buckets according to the end unit translation since this measurements are converted at the time of handling the event, prior to bucketing. Memory Report memory as :byte. Time Report durations as :second. The BEAM and :telemetry events use :native time units. Converting to seconds is as simple as adding the conversion tuple for the unit - {:native, :second} Naming Telemetry.Metrics definition names do not translate easily to Prometheus naming conventions. By default, the name provided when creating your definition uses parts of the provided name to determine what event to listen to and which event measurement to use. For example, http.request.duration results in listening for [:http, :request] events and use :duration from the event measurements. Prometheus would recommend a name of http_request_duration_seconds as a good name. It is therefore recommended to use the name in your definition to reflect the name you wish to see reported, e.g. http.request.duration.seconds or [:http, :request, :duration, :seconds] and use the :event_name override and :measurement options in your definition. Example: Metrics.distribution( &quot;http.request.duration.seconds&quot;, buckets: [0.01, 0.025, 0.05, 0.1, 0.2, 0.5, 1], event_name: [:http, :request, :complete], measurement: :duration, unit: {:native, :second} ) The exporter sanitizes names to Prometheus&#39; requirements Naming and joins the event name parts with an underscore. Labels Labels in Prometheus are referred to as :tags in Telemetry.Metrics - see the docs for more information on tag usage. Important: Each tag + value results in a separate time series. For distributions, this is further complicated as a time series is created for each bucket plus one for measurements exceeding the limit of the last bucket - +Inf. It is highly recommended to abide by Prometheus&#39; best practices regarding labels - Label Best Practices"},{"ref":"rationale.html","title":"Rationale","module":"rationale","type":"extras","doc":"Rationale We love the :telemetry ecosystem and everything it has to offer for instrumentation of our applications! We also love Prometheus, but wiring up handlers is time consuming and we couldn&#39;t find an existing Prometheus library that met our needs and offered the :telemetry + Telemetry.Metrics integration that we wanted. This project aims to fit a very specific need: reporting of :telemetry events in Prometheus format via Telemetery.Metrics definitions. There is no aim to create a full Prometheus client library. We think this package provides the best way to collect metrics in Elixir for Prometheus, but if your needs are different, other existing works may be a better fit. Check out the BEAM OpenCensus project, especially if you need a solution for Erlang."},{"ref":"rationale.html#why-include-a-server","title":"Rationale - Why include a server?","module":"rationale","type":"extras","doc":"It requires no modifications to your existing web server (assuming your app even has one!). It&#39;s much simpler to run a separate server versus adding a route and wiring up your scrape. Security. You don&#39;t have to lock down a route. You can keep the port the reporter is running on from being exposed to the outside world very simply with your infra configuration. Do you even web server, bruh? Maybe you&#39;re using Nerves! Maybe you want to instrument a background task. Whatever the case may be, we aim to make it easy to scrape via the included web server or push scrapes to a destination."}]